<?php

include("openssl_enc_dec.php");
if (isset($_REQUEST["cfg"])) {
    $sql_details = unserialize(urldecode(encrypt_decrypt('decrypt', $_REQUEST['cfg'])));
}
include("../dt/Editor/lib/DataTables.php");

date_default_timezone_set('Europe/Bratislava');
    
use
DataTables\Editor,
DataTables\Editor\Field,
DataTables\Editor\Format,
DataTables\Editor\Mjoin,
DataTables\Editor\Options,
DataTables\Editor\Upload,
DataTables\Editor\Validate,
DataTables\Editor\ValidateOptions;

$id_user = (isset($_POST['id_user']) ? $_POST['id_user'] + 0 : 0); // id uzivatela
$account_type = (isset($_POST['account_type']) ? $_POST['account_type'] + 0 : 1); // typ uctu
$lang = (isset($_REQUEST['lang']) ? $_REQUEST['lang'] : 'sk'); // jazyk

// Build our Editor instance and process the data coming from _POST
$editor = Editor::inst($db, 'users')
	->fields(
	    Field::inst('users.username')
		    ->validator(Validate::notEmpty(ValidateOptions::inst()
		        ->message('Povinný údaj')
	    ))
		    ->validator(Validate::unique(ValidateOptions::inst()
		        ->message(($lang == 'sk') ? 'Užívateľ už existuje' : 'Užívatel již existuje')
	    )),
		Field::inst('users.pw')
    	    ->validator(Validate::notEmpty(ValidateOptions::inst()
    	        ->message('Povinný údaj')
        )),
		Field::inst('users.firstname'),
	    Field::inst('users.lastname')
            ->validator(Validate::notEmpty(ValidateOptions::inst()
              ->message('Povinný údaj')
	    )),
		Field::inst('users.session') 
			-> set(false),
		Field::inst('users.account_type'),
		Field::inst('users.scroll_type'),
		Field::inst('users.order'),
		Field::inst('users.right_majetok')
			-> validator( function ($val, $data, $opts) {
				return (preg_match("/[0-1]{5}/", $val)) ? true : 'Nesprávne zadaná hodnota';
			}),
		Field::inst('users.right_inventura')
			-> validator( function ($val, $data, $opts) {
				return (preg_match("/[0-1]{5}/", $val)) ? true : 'Nesprávne zadaná hodnota';
            }),
		Field::inst('users.right_ciselniky')
		-> validator( function ($val, $data, $opts) {
		    return (preg_match("/[0-1]{5}/", $val)) ? true : 'Nesprávne zadaná hodnota';
        })
			
	) ;	

// odfiltruj len konkretneho uzivatela, pokial to nie je spravca	
if ($account_type != 0) {	
	$editor->where('users.id', $id_user);
}

$editor->on('preEdit', function ($e, $id, $values) {
    // file_put_contents('log', "values: ".print_r($values, true)."\n", FILE_APPEND);
    if ($values['users']['pw'] === 'none' ) {
        $e->field('users.pw')->set(false);
    } else {
        $e->field('users.pw')->setValue(md5($values['users']['pw']));
    }
});

$editor->on('preCreate', function ($e, $values) {
    if ($values['users']['pw'] === '' ) {
        $e->field('users.pw')->set(false);
    } else {
        $e->field('users.pw')->setValue(md5($values['users']['pw']));
    }
});
        
$out = $editor
->process($_POST)
->data();

echo json_encode($out);

?>